#!/usr/bin/perl
#
# SCoRE - Search a Corpus for Regular Expressions
#
# Perl module for ESF-specific routines - CHILDES data format so just use CHILDES package
#
# (c) Matthew Purver, King's College London, 2002
#
# $Log: $
#

package TALKBANK;

# export subroutines
require Exporter;
our @ISA = qw( Exporter );
our @EXPORT = qw( checkHeaderType 
		  getHeaderInfo
		  getSentence
		  removeSentence
		  noTags 
		  noTagsAtAll
		  highlight
		  fullPath
		  skipHeader 
		  skipAlign 
		  stringToRegExp );
our @EXPORT_OK = qw( %includeTypes $defaultIncludeType %excludeTypes $defaultExcludeType @dataDirs
		     $corpusFilePath $corpusListPath );

# imports
use SCoRE qw( $corpusPath $startDir );
use CHILDES qw( checkHeaderType getHeaderInfo getSentence removeSentence noTags noTagsAtAll
		highlight skipHeader skipAlign stringToRegExp );

# defines
$corpusFilePath = $corpusPath;				# path to corpus files
$corpusListPath = $corpusPath;				# path to corpus file lists
$startDir = ( $startDir eq '' ) ? '*/*.cha' : "$startDir/*.cha"; # dir spec

sub fullPath {
    my( $file ) = @_;

sub fullPath {
    my( $file ) = @_;

    ( $file =~ /$corpusFilePath/ ) or ( $file = "$corpusFilePath/$file" );
    return $file;
}


%includeTypes = ();
$defaultIncludeType = '';
%excludeTypes = ();
$defaultExcludeType = '';
@dataDirs = ( 'cmu', 'reading', 'sbcsae' );

# ensure package returns 1 to keep Perl happy
1;
